VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.UserControl SScontrol 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   960
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1350
   ControlContainer=   -1  'True
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   960
   ScaleWidth      =   1350
   Begin VB.TextBox XXcellTextbox 
      BorderStyle     =   0  'None
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Text            =   "Text Control"
      Top             =   630
      Visible         =   0   'False
      Width           =   1320
   End
   Begin MSFlexGridLib.MSFlexGrid XXgrid 
      Height          =   615
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1320
      _ExtentX        =   2328
      _ExtentY        =   1085
      _Version        =   65541
      AllowBigSelection=   0   'False
      ScrollTrack     =   -1  'True
      FocusRect       =   2
      AllowUserResizing=   3
      FormatString    =   "col 1|col 2;row 1|row 2"
   End
End
Attribute VB_Name = "SScontrol"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Binary

'******************************************************************************************
' This FREE control is intended to provide Active-X table creation and
' editing features to Web Browsers, without using either dynamic html or
' referencing version-specific libraries from Excel, etc.
'
' NO LIABILITY ACCEPTED OR SUPPORT OR WARRANTEE GIVEN.
'
' This FREE control can easily be used by your own VBscript programs
' (and probably Jscript too) and will work with both IE3 and IE4 and
' probably third party products which provide Active-X functionality to
' other browsers such as Netscape).
'
' A summary of functionality:
'       1. in-cell user-editing of cell contents
'       2. base-zero matrix cell referencing,
'               eg controlname.TextMatrix(irow,icol)="fred"
'       3. an InitializeSS method to quickly create a table with headings
'       4. an AutoSizeSS method to automatically resize the control
'          to the size of your table
'       5. exposes ClearSS method to clear all table values
'       6. exposes CellDataChange event to notify when a cell's value changes
'       7. exposes standard MSFLEXGRID events:
'               EnterCell(), LeaveCell(), RowColChange(), SelChange()
'       8. exposes almost all other MSFLEXGRID properties
'
' Smart developers could, for example, use this control as a basis to
' create FREE simple spreadsheet-like functionality for Web Browsers
' in VBSCRIPT or JSCRIPT, without having to pay a thing or have the
' requirement to have Excel libraries or similar products pre-installed.
' Of course, those same people could implement such functionality within
' the FREE souce code provided here.
'
' The only limitation is that such extensions MUST also be provided to
' the world on a FREE non-commercial basis and include complete source code.
'
' This FREE Active-X control created with VB5-sp3 is a wrapper for the
' standard Microsoft MSFLEXGRID control provided by products such as
' VB5-sp3. Both controls are freely distributable given this has been
' created by a fully licensed VB user).  The documentation that applies
' to the MSFLEXGRID control also applies to this control.
'
' Remember that some property/method arguments have been
' made into VARIANT types so that they are accessible to
' the VBSCRIPT engine (which only uses variants).
' Also remember this is intended as a run-time control and as
' such no design-time properties are "remembered" at run-time.
'
' SUMMARY of METHODS/EVENTS/PROPERTIES:
'
' 1. Methods are usable within VBscript,  eg FRED.ClearSS
'       Method InitializeSS(NoRows, NoCols, NoFixedRows, NoFixedCols, wantRowTotals, wantColTotals, numberVBformatString, theFontName, theFontSize, theMSFlexGridFormatString)
'         NoRows = number of rows in the table (incl row headings)
'         NoCols = number of rows in the table (incl col headings)
'         NoFixedRows = number of heading rows
'         NoFixedCols = number of heading columns
'         wantRowTotals = true if want row total processing
'         wantColTotals = true if want column total processing
'         numberVBformatString = the VB "format string" for formatting numbers eg "###,###,##0.00"
'         theFontName = font name string
'         theFontSize = font size number
'         theMSFlexGridFormatString = row/col heading/alignment format string
'               MSFlexGrid parses the FormatString at design time and interprets
'               it to get the following information: number of rows and columns, text
'               for row and column headings, column width, and column alignment.
'               The FormatString property is made up of segments separated by pipe
'               characters ( | ). The text between pipes defines a column, and it may
'               contain the special alignment characters <, ^, or >, to align the entire
'               column to the left, center, or right. The text is assigned to row zero,
'               and its width defines the width of each column.
'               The FormatString may also contain a semi-colon (";"), which causes the
'               remainder of the string to be interpreted as row heading and width
'               information. The text is assigned to column zero, and the longest string
'               defines the width of column zero.
'               MSFlexGrid will create additional rows and columns to accommodate all
'               fields defined by the FormatString, but it will not delete rows or columns
'               if only a few fields are specified. If you want, you can do this by setting
'               the Rows and Cols properties.
'                 examples:
'                 ' Set column headers:
'                     "<Region  |<Product   |<Employee   |>Sales    "
'                 ' Set row headers (note semicolon at start)
'                     ";Name|Address|Telephone|Social Security#"
'                 ' Set column and row headers.
'                     "|Name|Address|Telephone|Social Security#;|Robert|Jimmy|Bonzo|John Paul"
'       Method ClearSS()                      clear table values
'       Method AutoSizeSS()                   resize control to size of table
'       Method AddItem(Item, Optional Index)
'       Method RemoveItem(Index)
'       Method Refresh()                      refresh the table
'       Method RecalculateTotals()            refresh table totals
'
' 2. Events are usable within VBscript by preceding the event
'    name with "controlname_",
'                               SUB FRED_EnterCell()
'                                       'your processing such as
'                                       irow = FRED.Row
'                                       icol = FRED.Col
'                                       ival = FRED.TextMatrix(irow,icol)
'                               END SUB
'       Event EnterCell()
'       Event LeaveCell()
'       Event RowColChange()
'       Event SelChange()
'       Event CellDataChange(theRow, theCol, PreChangeData, PostChangeData, ChangeSequenceNo)
'
' 3. Properties are usable within VBscript,  eg FRED.Width
'          Property  Rows() As Long
'          Attribute Rows.VB_Description = "Determines the total number of columns or rows in a FlexGrid."
'          Property  Cols() As Long
'          Attribute Cols.VB_Description = "Determines the total number of columns or rows in a FlexGrid."
'
'          Property  Row() As Long
'          Attribute Row.VB_Description = "Returns/sets the active cell in a FlexGrid. Not available at design time."
'          Property  Col() As Long
'          Attribute Col.VB_Description = "Returns/sets the active cell in a FlexGrid. Not available at design time."
'
'          Property  TextMatrix(Row As Variant, Col As Variant) As String
'          Attribute Text.VB_Description = "Returns/sets the value of the specified cell in a FlexGrid. Not available at design time."
'
'          Property  Text() As String
'          Attribute Text.VB_Description = "Returns/sets the value of the active cell in a FlexGrid. Not available at design time."
'          Property  TextArray(Index As Variant) As String
'          Attribute Text.VB_Description = "Returns/sets the value of the active cell in a FlexGrid. Not available at design time."
'
'          Property  FixedRows() As Long
'          Attribute FixedRows.VB_Description = "Returns/sets the total number of fixed (non-scrollable) columns or rows for a FlexGrid."
'          Property  FixedCols() As Long
'          Attribute FixedCols.VB_Description = "Returns/sets the total number of fixed (non-scrollable) columns or rows for a FlexGrid."
'
'          Property  FormatString() As String
'          Attribute FormatString.VB_Description = "Allows you to set up a FlexGrid's column widths, alignments, and fixed row and column text at design time. See the help file for details."
'
'          Property  Font() As Font
'          Attribute Font.VB_Description = "Returns/sets the default font Object attributes for individual cells."
'
'          Property  RowIsVisible(Index As Variant) As Boolean
'
'          Property  TopRow() As Long
'          Attribute TopRow.VB_Description = "Returns/sets the uppermost row *displayed* in the FlexGrid. Not available at design time."
'          Property  LeftCol() As Long
'          Attribute LeftCol.VB_Description = "Returns/sets the leftmost visible column *displayed* (other than a fixed column) in the FlexGrid. Not available at design time."
'
'          Property  AllowBigSelection() As Boolean
'          Attribute AllowBigSelection.VB_Description = "Returns/sets whether clicking on a column or row header should cause the entire column or row to be selected."
'          Property  AllowUserResizing() As AllowUserResizeSettings
'          Attribute AllowUserResizing.VB_Description = "Returns/sets whether the user should be allowed to resize rows and columns with the mouse."
'          Property  Appearance() As AppearanceSettings
'          Attribute Appearance.VB_Description = "Returns/sets whether a control should be painted with 3-D effects."
'          Property  CellAlignment() As Integer
'          Attribute CellAlignment.VB_Description = "Returns/sets the alignment of data in a cell or range of selected cells. Not available at design time."
'          Property  CellBackColor() As Long
'          Attribute CellBackColor.VB_Description = "Returns/sets the background and foreground colors of individual cells or ranges of cells."
'          Property  CellFontBold() As Boolean
'          Attribute CellFontBold.VB_Description = "Returns or sets the bold style for the current cell text."
'          Property  CellFontItalic() As Boolean
'          Attribute CellFontItalic.VB_Description = "Returns or sets the italic style for the current cell text."
'          Property  CellFontName() As String
'          Attribute CellFontName.VB_Description = "Returns/sets the font to be used for individual cells or ranges of cells."
'          Property  CellFontSize() As Single
'          Attribute CellFontSize.VB_Description = "Returns or sets the size, in points, for the current cell text."
'          Property  CellFontStrikeThrough() As Boolean
'          Attribute CellFontStrikeThrough.VB_Description = "Returns or sets the strikethrough style for the current cell text."
'          Property  CellFontUnderline() As Boolean
'          Attribute CellFontUnderline.VB_Description = "Returns or sets the underline style for the current cell text."
'          Property  CellFontWidth() As Single
'          Attribute CellFontWidth.VB_Description = "Returns or sets the font width for the current cell text."
'          Property  CellForeColor() As Long
'          Attribute CellForeColor.VB_Description = "Returns/sets the background and foreground colors of individual cells or ranges of cells."
'          Property  CellHeight() As Long
'          Property  CellLeft() As Long
'          Property  CellPicture() As Picture
'          Attribute CellPicture.VB_Description = "Returns/sets an image to be displayed in the current cell or in a range of cells."
'          Property  CellPictureAlignment() As Integer
'          Attribute CellPictureAlignment.VB_Description = "Returns/sets the alignment of pictures in a cell or range of selected cells. Not available at design time."
'          Property  CellTextStyle() As TextStyleSettings
'          Attribute CellTextStyle.VB_Description = "Returns/sets 3D effects for text on a specific cell or range of cells."
'          Property  CellTop() As Long
'          Property  CellWidth() As Long
'          Property  ColAlignment(Index As Variant) As Integer
'          Property  ColAlignment(Index As Variant, ByVal New_ColAlignment As Integer)
'          Attribute ColAlignment.VB_Description = "Returns/sets the alignment of data in a column. Not available at design time (except indirectly through the FormatString property)."
'          Property  ColData(Index As Variant) As Long
'          Attribute ColData.VB_Description = "Array of long integer values with one item for each row (RowData) and for each column (ColData) of the FlexGrid. Not available at design time."
'          Property  ColIsVisible(Index As Variant) As Boolean
'          Property  ColPos(Index As Variant) As Long
'        COLPOSITION is LET only (no GET)
'          Property  ColPosition(Index As Variant, ByVal New_ColPosition As Long)
'          Property  ColSel() As Long
'          Attribute ColSel.VB_Description = "Determines the starting or ending row or column for a range of cells. Not available at design time."
'          Property  ColWidth(Index As Variant) As Long
'          Attribute ColWidth.VB_Description = "Determines the width of the specified column in Twips. Not available at design time."
'          Property  DataBindings() As DataBindings
'          Property  DataSource() As IRowCursor
'          Property  Enabled() As Boolean
'          Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
'          Property  FillStyle() As FillStyleSettings
'          Attribute FillStyle.VB_Description = "Determines whether setting the Text property or one of the Cell formatting properties of a FlexGrid applies the change to all selected cells."
'          Property  FixedAlignment(Index As Variant) As Integer
'          Attribute FixedAlignment.VB_Description = "Returns/sets the alignment of data in the fixed cells of a column."
'          Property  FocusRect() As FocusRectSettings
'          Attribute FocusRect.VB_Description = "Determines whether the FlexGrid control should draw a focus rectangle around the current cell."
'          Property  FontWidth() As Single
'          Attribute FontWidth.VB_Description = "Returns or sets the width, in points, of the font to be used for text displayed."
'          Property  ForeColor() As OLE_COLOR
'          Attribute ForeColor.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
'          Property  ForeColorFixed() As Long
'          Attribute ForeColorFixed.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
'          Property  ForeColorSel() As Long
'          Attribute ForeColorSel.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
'          Property  GridColor() As Long
'          Attribute GridColor.VB_Description = "Returns/sets the color used to draw the lines between FlexGrid cells."
'          Property  GridColorFixed() As Long
'          Attribute GridColorFixed.VB_Description = "Returns/sets the color used to draw the lines between FlexGrid cells."
'          Property  GridLines() As GridLineSettings
'          Attribute GridLines.VB_Description = "Returns/sets the type of lines that should be drawn between cells."
'          Property  GridLinesFixed() As GridLineSettings
'          Attribute GridLinesFixed.VB_Description = "Returns/sets the type of lines that should be drawn between cells."
'          Property  GridLineWidth() As Integer
'          Attribute GridLineWidth.VB_Description = "Returns/sets the width in Pixels of the gridlines for the control."
'          Property  HaveColTotals() As Boolean
'          Property  HaveRowTotals() As Boolean
'          Property  HighLight() As HighLightSettings
'          Attribute HighLight.VB_Description = "Returns/sets whether selected cells appear highlighted."
'          Property  MergeCells() As MergeCellsSettings
'          Attribute MergeCells.VB_Description = "Returns/sets whether cells with the same contents should be grouped in a single cell spanning multiple rows or columns."
'          Property  MergeCol(Index As Variant) As Boolean
'          Attribute MergeCol.VB_Description = "Returns/sets which rows (columns) should have their contents merged when the MergeCells property is set to a value other than 0 - Never."
'          Property  MergeRow(Index As Variant) As Boolean
'          Attribute MergeRow.VB_Description = "Returns/sets which rows (columns) should have their contents merged when the MergeCells property is set to a value other than 0 - Never."
'          Property  MouseCol() As Long
'          Property  Set MouseIcon(ByVal New_MouseIcon As Picture)
'          Property  MousePointer() As MousePointerSettings
'          Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
'          Property  MouseRow() As Long
'          Property  NumberVBformatString as String
'          Property  Picture() As Picture
'          Property  Redraw() As Boolean
'          Attribute Redraw.VB_Description = "Enables or disables redrawing of the FlexGrid control."
'          Property  RowData(Index As Variant) As Long
'          Attribute RowData.VB_Description = "Array of long integer values with one item for each row (RowData) and for each column (ColData) of the FlexGrid. Not available at design time."
'          Property  RowHeight(Index As Variant) As Long
'          Attribute RowHeight.VB_Description = "Returns/sets the height of the specified row in Twips. Not available at design time."
'          Property  RowHeightMin() As Long
'          Attribute RowHeightMin.VB_Description = "Returns/sets a minimum row height for the entire control, in Twips."
'          Property  RowPos(Index As Variant) As Long
'         ROWPOSITION is SET only (no GET)
'          Property  RowPosition(Index As Variant, ByVal New_RowPosition As Long)
'          Property  RowSel() As Long
'          Attribute RowSel.VB_Description = "Determines the starting or ending row or column for a range of cells. Not available at design time."
'          Property  ScrollBars() As ScrollBarsSettings
'          Attribute ScrollBars.VB_Description = "Returns/sets whether a FlexGrid has horizontal or vertical scroll bars."
'          Property  ScrollTrack() As Boolean
'          Attribute ScrollTrack.VB_Description = "Returns/sets whether FlexGrid should scroll its contents while the user moves the scroll box along the scroll bars."
'         SORT is SET only (no GET)
'          Property  Sort(ByVal New_Sort As Variant)
'          Property  TextStyle() As TextStyleSettings
'          Attribute TextStyle.VB_Description = "Returns/sets 3D effects for displaying text."
'          Property  TextStyleFixed() As TextStyleSettings
'          Attribute TextStyleFixed.VB_Description = "Returns/sets 3D effects for displaying text."
'          Property  ToolTipText() As String
'          Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
'          Property  Version() As Integer
'          Attribute Version.VB_Description = "Returns the version of the FlexGrid control currently loaded in memory."
'          Property  WordWrap() As Boolean
'          Property  Width() As Double
'          Property  Height() As Double
'
'******************************************************************************************
Private PreEditCellData As String
Private EditSequenceNo As Long

'Default Property Values:

'Property Variables:
Private pHaveRowTotals As Boolean
Private pHaveColTotals As Boolean
Private pNumberVBformatString As String

'Event Declarations:
'Event Compare(Row1 As Long, Row2 As Long, Cmp As Integer) 'MappingInfo=XXgrid,XXgrid,-1,Compare
Event EnterCell() 'MappingInfo=XXgrid,XXgrid,-1,EnterCell
Event LeaveCell() 'MappingInfo=XXgrid,XXgrid,-1,LeaveCell
Event RowColChange() 'MappingInfo=XXgrid,XXgrid,-1,RowColChange
Event SelChange() 'MappingInfo=XXgrid,XXgrid,-1,SelChange
Event CellDataChange(theRow As Long, theCol As Long, PreChangeData As String, PostChangeData As String, SequenceNo As Long)     'MappingInfo=XXgrid,XXgrid,-1,CellDataChange

Public Sub ClearSS()
  XXgrid.Clear
End Sub

Public Sub AutoSizeSS()
Dim i, j, lw As Double, lh As Double, gw As Double, gh As Double

  DoEvents
  gw = XXgrid.GridLineWidth * Screen.TwipsPerPixelX
  If XXgrid.Cols < 11 Then gw = gw * 2
  gh = XXgrid.GridLineWidth * Screen.TwipsPerPixelY
  lw = 36 + gw + 36
  lh = 31 + gh + 31
  For i = 0 To XXgrid.Rows - 1
    lh = lh + XXgrid.RowHeight(i) + XXgrid.GridLineWidth
  Next
  For j = 0 To XXgrid.Cols - 1
    lw = lw + XXgrid.ColWidth(j) + XXgrid.GridLineWidth
  Next
  UserControl.Width = lw
  UserControl.Height = lh
'UserControl_Resize gets automatically called by changing these
  DoEvents
End Sub

Private Sub UserControl_Initialize()
  PreEditCellData = ""
  EditSequenceNo = 0
  pHaveRowTotals = False
  pHaveColTotals = False
  pNumberVBformatString = "###,###,###,##0.00"
End Sub

Public Sub InitializeSS(NRows As Variant, NCols As Variant, NFixedRows As Variant, NFixedCols As Variant, wantRowTotals As Variant, wantColTotals As Variant, NumberVBformatString As Variant, theFontName As Variant, theFontSize As Variant, theMSFlexGridFormatString As Variant)
'  MsgBox "InitializeSS(" & NRows & "," & NCols & "," & NFixedRows & "," & NFixedCols & "," & wantRowTotals & "," & wantColTotals & "," & NumberVBformatString & "," & theFontName & "," & theFontSize & "," & theMSFlexGridFormatString & ")"
  PreEditCellData = ""
  EditSequenceNo = 0
' Always (re)set to zero to avoid errors when fixedrows >= rows
  XXgrid.Clear
  XXgrid.FormatString = ""
  XXgrid.FixedRows = 0
  XXgrid.FixedCols = 0
  XXgrid.Rows = 0
  XXgrid.Cols = 0

  UserControl.Font.Name = theFontName
  UserControl.Font.Size = theFontSize
  Call SyncFonts
  PropertyChanged "Font"
  
  XXgrid.Rows = NRows
  PropertyChanged "Rows"
  XXgrid.Cols = NCols
  PropertyChanged "Cols"
  
  XXgrid.FixedRows = NFixedRows
  PropertyChanged "FixedRows"
  XXgrid.FixedCols = NFixedCols
  PropertyChanged "FixedCols"

  XXgrid.FormatString = theMSFlexGridFormatString
  PropertyChanged "FormatString"
  XXgrid.Refresh
  Call UserControl_Resize
  XXcellTextbox.Text = ""
  
  pHaveRowTotals = wantRowTotals
  PropertyChanged "HaveRowTotals"
  pHaveColTotals = wantColTotals
  PropertyChanged "HaveColTotals"
  pNumberVBformatString = NumberVBformatString
  PropertyChanged "NumberVBformatString"
  
  Call ZeroRowColumnTotals
  DoEvents
End Sub

Private Sub XXgrid_DblClick()
   XXgridEdit Asc(" ")
End Sub

Private Sub XXgrid_KeyPress(KeyAscii As Integer)
Dim irow As Long, icol As Long, old_text As String
   Select Case KeyAscii
      Case vbKeyBack          'backspace
        irow = XXgrid.Row
        icol = XXgrid.Col
        old_text = XXgrid.TextMatrix(irow, icol)
        XXgrid.TextMatrix(irow, icol) = ""
        Call ProcessCellDataChange(irow, icol, old_text, "")
      Case Else
        XXgridEdit KeyAscii
    End Select
End Sub

Private Sub XXgridEdit(KeyAscii As Integer)
'For demonstration purposes, the Case statement in the XXgridEdit
'routine shows two different behaviors when entering the edit
'mode. In practice you would probably only use one of them, or
'a different one of your own creation. If the edit mode is
'entered by virtue of a double-click or a control key preXXgrid,
'we copy the contents of the grid cell to the exit box and
'place the cursor at the end of the string. If the edit mode
'is entered by pressing a normal key, we ignore the original
'cell contents and insert the pressed key into the edit box.
'The positioning of the exit box could be done on one line
'with the Move method. Here we have used four lines so that
'it reads more easily in this article. Notice that
'MSFlexGrid conveniently gives us all the coordinate
'information we need.
   'use correct font
'   XXcellTextbox.FontName = XXgrid.FontName
'   XXcellTextbox.FontSize = XXgrid.FontSize
   Select Case KeyAscii
      Case 0 To Asc(" ")
         XXcellTextbox.Text = XXgrid.Text
         XXcellTextbox.SelStart = 1000
      Case Else
         XXcellTextbox.Text = Chr(KeyAscii)
         XXcellTextbox.SelStart = 1
   End Select
   PreEditCellData = XXgrid.Text
'position the edit box
   XXcellTextbox.Left = XXgrid.CellLeft + XXgrid.Left
   XXcellTextbox.Top = XXgrid.CellTop + XXgrid.Top
   XXcellTextbox.Width = XXgrid.CellWidth
   XXcellTextbox.Height = XXgrid.CellHeight
   XXcellTextbox.Visible = True
   XXcellTextbox.SetFocus
End Sub

Private Sub ProcessCellDataChange(theRow As Long, theCol As Long, PreChangeData As String, PostChangeData As String)
'Before raising the Event, check for and update totals

  If IsNumeric(PostChangeData) And (theRow >= XXgrid.FixedRows And theCol >= XXgrid.FixedCols) Then
    XXgrid.TextMatrix(theRow, theCol) = Format$(CDbl(PostChangeData), pNumberVBformatString)
  End If
  Call SumTheQuickWay(theRow, theCol, PreChangeData, PostChangeData)
  
  RaiseEvent CellDataChange(theRow, theCol, PreChangeData, PostChangeData, EditSequenceNo)
  EditSequenceNo = EditSequenceNo + 1
  PreEditCellData = PostChangeData ' so no cascaded events
End Sub

Public Sub ZeroRowColumnTotals()
  Dim i As Long, j As Long
    If pHaveRowTotals Then
      For i = XXgrid.FixedRows To ((XXgrid.Rows - 1) - 1)
        XXgrid.TextMatrix(i, (XXgrid.Cols - 1)) = Format$(0#, pNumberVBformatString)
      Next
    End If
    If pHaveColTotals Then
      For j = XXgrid.FixedCols To ((XXgrid.Cols - 1) - 1)
        XXgrid.TextMatrix((XXgrid.Rows - 1), j) = Format$(0#, pNumberVBformatString)
      Next
    End If
    If pHaveRowTotals Or pHaveColTotals Then
      XXgrid.TextMatrix(XXgrid.Rows - 1, XXgrid.Cols - 1) = Format$(0#, pNumberVBformatString)
    End If
End Sub

Private Sub SumTheQuickWay(theRow As Long, theCol As Long, PreChangeData As String, PostChangeData As String)
' (do it the quick but messy way)
' Assume everything starts out as pre-calculated and all OK (it this won't work)
  Dim iTotalForRow As Long
  Dim jTotalForRow As Long
  Dim iTotalForCol As Long
  Dim jTotalForCol As Long
  Dim iGT As Long
  Dim jGT As Long
  Dim TotalForRow As Double
  Dim TotalForCol As Double
  Dim GT As Double
  Dim v As Double
  
  If (pHaveRowTotals Or pHaveColTotals) And (theRow >= XXgrid.FixedRows And theCol >= XXgrid.FixedCols) Then
    MousePointer = vbHourglass
    v = 0#
    If IsNumeric(PostChangeData) Then v = CDbl(PostChangeData)
    iTotalForRow = theRow
    jTotalForRow = XXgrid.Cols - 1
    iTotalForCol = XXgrid.Rows - 1
    jTotalForCol = theCol
    iGT = XXgrid.Rows - 1
    jGT = XXgrid.Cols - 1
    If Not IsNumeric(XXgrid.TextMatrix(iTotalForRow, jTotalForRow)) Then
      TotalForRow = 0#
    Else
      TotalForRow = CDbl(XXgrid.TextMatrix(iTotalForRow, jTotalForRow))
    End If
    If Not IsNumeric(XXgrid.TextMatrix(iTotalForCol, jTotalForCol)) Then
      TotalForCol = 0#
    Else
      TotalForCol = CDbl(XXgrid.TextMatrix(iTotalForCol, jTotalForCol))
    End If
    If Not IsNumeric(XXgrid.TextMatrix(iGT, jGT)) Then
      GT = 0#
    Else
      GT = CDbl(XXgrid.TextMatrix(iGT, jGT))
    End If
    If IsNumeric(PreChangeData) Then
      TotalForRow = TotalForRow - CDbl(PreChangeData)
      TotalForCol = TotalForCol - CDbl(PreChangeData)
      GT = GT - CDbl(PreChangeData)
    End If
    XXgrid.TextMatrix(iTotalForRow, jTotalForRow) = Format$(TotalForRow + v, pNumberVBformatString)
    XXgrid.TextMatrix(iTotalForCol, jTotalForCol) = Format$(TotalForCol + v, pNumberVBformatString)
    XXgrid.TextMatrix(iGT, jGT) = Format$(GT + v, pNumberVBformatString)
    MousePointer = vbDefault
  End If
End Sub

Public Sub RecalculateTotals()
' (do it the long and hard way - parse whole table every time)
  Dim i As Long, j As Long
  Dim v As Double, GrandTotal As Double
  
  'If (pHaveRowTotals Or pHaveColTotals) And (theRow >= XXgrid.FixedRows And theCol >= XXgrid.FixedCols) Then
  If pHaveRowTotals Or pHaveColTotals Then
    MousePointer = vbHourglass
    ReDim TotalsForEachCol(XXgrid.FixedCols To ((XXgrid.Cols - 1) - 1)) As Double
    GrandTotal = 0
    For j = XXgrid.FixedCols To ((XXgrid.Cols - 1) - 1)
      TotalsForEachCol(j) = 0#
    Next
    ReDim TotalsForEachRow(XXgrid.FixedRows To ((XXgrid.Rows - 1) - 1)) As Double
    For i = XXgrid.FixedRows To ((XXgrid.Rows - 1) - 1)
      TotalsForEachRow(i) = 0#
    Next
    For i = XXgrid.FixedRows To ((XXgrid.Rows - 1) - 1)
      For j = XXgrid.FixedCols To ((XXgrid.Cols - 1) - 1)
        If IsNumeric(XXgrid.TextMatrix(i, j)) Then
          v = CDbl(XXgrid.TextMatrix(i, j))
          TotalsForEachRow(i) = TotalsForEachRow(i) + v
          TotalsForEachCol(j) = TotalsForEachCol(j) + v
          GrandTotal = GrandTotal + v
        End If
      Next
    Next
    If pHaveRowTotals Then
      For i = XXgrid.FixedRows To ((XXgrid.Rows - 1) - 1)
        XXgrid.TextMatrix(i, (XXgrid.Cols - 1)) = Format$(TotalsForEachRow(i), pNumberVBformatString)
      Next
    End If
    If pHaveColTotals Then
      For j = XXgrid.FixedCols To ((XXgrid.Cols - 1) - 1)
        XXgrid.TextMatrix((XXgrid.Rows - 1), j) = Format$(TotalsForEachCol(j), pNumberVBformatString)
      Next
    End If
    XXgrid.TextMatrix(XXgrid.Rows - 1, XXgrid.Cols - 1) = Format$(GrandTotal, pNumberVBformatString)
    Erase TotalsForEachCol, TotalsForEachRow
    MousePointer = vbDefault
  End If
End Sub

Private Sub XXgrid_LeaveCell()
Dim the_row As Long, the_col As Long
   the_row = XXgrid.Row
   the_col = XXgrid.Col
   If XXcellTextbox.Visible Then
      XXgrid.Text = XXcellTextbox.Text
      If PreEditCellData <> XXcellTextbox.Text Then
        Call ProcessCellDataChange(the_row, the_col, PreEditCellData, XXcellTextbox.Text)
      End If
      XXcellTextbox.Visible = False
   End If
  RaiseEvent LeaveCell
End Sub

Private Sub XXgrid_GotFocus()
Dim the_row As Long, the_col As Long
   the_row = XXgrid.Row
   the_col = XXgrid.Col
   If XXcellTextbox.Visible Then
      XXgrid.Text = XXcellTextbox.Text
      XXcellTextbox.Visible = False
      If PreEditCellData <> XXcellTextbox.Text Then
        Call ProcessCellDataChange(the_row, the_col, PreEditCellData, XXcellTextbox.Text)
      End If
   End If
End Sub

Private Sub XXcellTextbox_KeyDown(KeyCode As Integer, Shift As Integer)
   Select Case KeyCode
      Case vbKeyEscape    'escape
         XXcellTextbox.Visible = False
         XXgrid.SetFocus
      Case vbKeyReturn    'enter
         XXgrid.SetFocus
      Case vbKeyDown      'down arrow
         XXgrid.SetFocus
         DoEvents
         If XXgrid.Row < XXgrid.Rows - 1 Then
            XXgrid.Row = XXgrid.Row + 1     ' do the move regardless
            If WillOverwriteTotals(XXgrid.Row, XXgrid.Col) Then 'backout if gone too far
              XXgrid.Row = XXgrid.Row - 1
            End If
         End If
      Case vbKeyUp      'up arrow
         XXgrid.SetFocus
         DoEvents
         If XXgrid.Row > XXgrid.FixedRows Then
            XXgrid.Row = XXgrid.Row - 1
         End If
   End Select
End Sub

Private Sub XXcellTextbox_KeyPress(KeyAscii As Integer)
'we need a line of code to suppress the Beep that
'occurs when the Enter key is pressed in a Textbox
   'noise suppression
   If KeyAscii = vbKeyReturn Then KeyAscii = 0
End Sub

Private Sub UserControl_Resize()
' Size the SS control external size to fit it's container
' - it generates own internal scollbars if necessary !
  DoEvents
  XXgrid.Move 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
  DoEvents
End Sub

Private Function WillOverwriteTotals(irow As Long, icol As Long)
' Check that a proposed update does not impinge on row/col totals
  WillOverwriteTotals = False
  If pHaveRowTotals Then
    If (irow >= XXgrid.FixedRows) And (icol = XXgrid.Cols - 1) Then
      WillOverwriteTotals = True
    End If
  End If
  If pHaveColTotals Then
    If (icol >= XXgrid.FixedCols) And (irow = XXgrid.Rows - 1) Then
      WillOverwriteTotals = True
    End If
  End If
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,HaveRowTotals
Public Property Get HaveRowTotals() As Boolean
  HaveRowTotals = pHaveRowTotals
End Property

Public Property Let HaveRowTotals(ByVal New_HaveRowTotals As Boolean)
  pHaveRowTotals = New_HaveRowTotals
  If pHaveRowTotals Then Call RecalculateTotals
  PropertyChanged "HaveRowTotals"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,HaveColTotals
Public Property Get HaveColTotals() As Boolean
  HaveColTotals = pHaveColTotals
End Property

Public Property Let HaveColTotals(ByVal New_HaveColTotals As Boolean)
  pHaveColTotals = New_HaveColTotals
  If pHaveColTotals Then Call RecalculateTotals
  PropertyChanged "HaveColTotals"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,NumberVBformatString
Public Property Get NumberVBformatString() As String
  NumberVBformatString = pNumberVBformatString
End Property

Public Property Let NumberVBformatString(New_NumberVBformatString As String)
  pNumberVBformatString = New_NumberVBformatString
  PropertyChanged "NumberVBformatString"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,AddItem
'Public Sub AddItem(Item As String, Optional Index As Variant)
Public Sub AddItem(Item As Variant, Optional Index As Variant)
  XXgrid.AddItem Item, Index
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,AllowBigSelection
Public Property Get AllowBigSelection() As Boolean
Attribute AllowBigSelection.VB_Description = "Returns/sets whether clicking on a column or row header should cause the entire column or row to be selected."
  AllowBigSelection = XXgrid.AllowBigSelection
End Property

Public Property Let AllowBigSelection(ByVal New_AllowBigSelection As Boolean)
  XXgrid.AllowBigSelection = New_AllowBigSelection
  PropertyChanged "AllowBigSelection"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,AllowUserResizing
Public Property Get AllowUserResizing() As AllowUserResizeSettings
Attribute AllowUserResizing.VB_Description = "Returns/sets whether the user should be allowed to resize rows and columns with the mouse."
  AllowUserResizing = XXgrid.AllowUserResizing
End Property

Public Property Let AllowUserResizing(ByVal New_AllowUserResizing As AllowUserResizeSettings)
  XXgrid.AllowUserResizing = New_AllowUserResizing
  PropertyChanged "AllowUserResizing"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Appearance
Public Property Get Appearance() As AppearanceSettings
Attribute Appearance.VB_Description = "Returns/sets whether a control should be painted with 3-D effects."
  Appearance = XXgrid.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As AppearanceSettings)
  XXgrid.Appearance = New_Appearance
  PropertyChanged "Appearance"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellAlignment
Public Property Get CellAlignment() As Integer
Attribute CellAlignment.VB_Description = "Returns/sets the alignment of data in a cell or range of selected cells. Not available at design time."
  CellAlignment = XXgrid.CellAlignment
End Property

Public Property Let CellAlignment(ByVal New_CellAlignment As Integer)
  XXgrid.CellAlignment = New_CellAlignment
  PropertyChanged "CellAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellBackColor
Public Property Get CellBackColor() As Long
Attribute CellBackColor.VB_Description = "Returns/sets the background and foreground colors of individual cells or ranges of cells."
  CellBackColor = XXgrid.CellBackColor
End Property

Public Property Let CellBackColor(ByVal New_CellBackColor As Long)
  XXgrid.CellBackColor = New_CellBackColor
  PropertyChanged "CellBackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellFontBold
Public Property Get CellFontBold() As Boolean
Attribute CellFontBold.VB_Description = "Returns or sets the bold style for the current cell text."
  CellFontBold = XXgrid.CellFontBold
End Property

Public Property Let CellFontBold(ByVal New_CellFontBold As Boolean)
  XXgrid.CellFontBold = New_CellFontBold
  PropertyChanged "CellFontBold"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellFontItalic
Public Property Get CellFontItalic() As Boolean
Attribute CellFontItalic.VB_Description = "Returns or sets the italic style for the current cell text."
  CellFontItalic = XXgrid.CellFontItalic
End Property

Public Property Let CellFontItalic(ByVal New_CellFontItalic As Boolean)
  XXgrid.CellFontItalic = New_CellFontItalic
  PropertyChanged "CellFontItalic"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellFontName
Public Property Get CellFontName() As String
Attribute CellFontName.VB_Description = "Returns/sets the font to be used for individual cells or ranges of cells."
  CellFontName = XXgrid.CellFontName
End Property

Public Property Let CellFontName(ByVal New_CellFontName As String)
  XXgrid.CellFontName = New_CellFontName
  PropertyChanged "CellFontName"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellFontSize
Public Property Get CellFontSize() As Single
Attribute CellFontSize.VB_Description = "Returns or sets the size, in points, for the current cell text."
  CellFontSize = XXgrid.CellFontSize
End Property

Public Property Let CellFontSize(ByVal New_CellFontSize As Single)
  XXgrid.CellFontSize = New_CellFontSize
  PropertyChanged "CellFontSize"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellFontStrikeThrough
Public Property Get CellFontStrikeThrough() As Boolean
Attribute CellFontStrikeThrough.VB_Description = "Returns or sets the strikethrough style for the current cell text."
  CellFontStrikeThrough = XXgrid.CellFontStrikeThrough
End Property

Public Property Let CellFontStrikeThrough(ByVal New_CellFontStrikeThrough As Boolean)
  XXgrid.CellFontStrikeThrough = New_CellFontStrikeThrough
  PropertyChanged "CellFontStrikeThrough"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellFontUnderline
Public Property Get CellFontUnderline() As Boolean
Attribute CellFontUnderline.VB_Description = "Returns or sets the underline style for the current cell text."
  CellFontUnderline = XXgrid.CellFontUnderline
End Property

Public Property Let CellFontUnderline(ByVal New_CellFontUnderline As Boolean)
  XXgrid.CellFontUnderline = New_CellFontUnderline
  PropertyChanged "CellFontUnderline"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellFontWidth
Public Property Get CellFontWidth() As Single
Attribute CellFontWidth.VB_Description = "Returns or sets the font width for the current cell text."
  CellFontWidth = XXgrid.CellFontWidth
End Property

Public Property Let CellFontWidth(ByVal New_CellFontWidth As Single)
  XXgrid.CellFontWidth = New_CellFontWidth
  PropertyChanged "CellFontWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellForeColor
Public Property Get CellForeColor() As Long
Attribute CellForeColor.VB_Description = "Returns/sets the background and foreground colors of individual cells or ranges of cells."
  CellForeColor = XXgrid.CellForeColor
End Property

Public Property Let CellForeColor(ByVal New_CellForeColor As Long)
  XXgrid.CellForeColor = New_CellForeColor
  PropertyChanged "CellForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellHeight
Public Property Get CellHeight() As Long
  CellHeight = XXgrid.CellHeight
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellLeft
Public Property Get CellLeft() As Long
  CellLeft = XXgrid.CellLeft
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellPicture
Public Property Get CellPicture() As Picture
Attribute CellPicture.VB_Description = "Returns/sets an image to be displayed in the current cell or in a range of cells."
  Set CellPicture = XXgrid.CellPicture
End Property

Public Property Set CellPicture(ByVal New_CellPicture As Picture)
  Set XXgrid.CellPicture = New_CellPicture
  PropertyChanged "CellPicture"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellPictureAlignment
Public Property Get CellPictureAlignment() As Integer
Attribute CellPictureAlignment.VB_Description = "Returns/sets the alignment of pictures in a cell or range of selected cells. Not available at design time."
  CellPictureAlignment = XXgrid.CellPictureAlignment
End Property

Public Property Let CellPictureAlignment(ByVal New_CellPictureAlignment As Integer)
  XXgrid.CellPictureAlignment = New_CellPictureAlignment
  PropertyChanged "CellPictureAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellTextStyle
Public Property Get CellTextStyle() As TextStyleSettings
Attribute CellTextStyle.VB_Description = "Returns/sets 3D effects for text on a specific cell or range of cells."
  CellTextStyle = XXgrid.CellTextStyle
End Property

Public Property Let CellTextStyle(ByVal New_CellTextStyle As TextStyleSettings)
  XXgrid.CellTextStyle = New_CellTextStyle
  PropertyChanged "CellTextStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellTop
Public Property Get CellTop() As Long
  CellTop = XXgrid.CellTop
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,CellWidth
Public Property Get CellWidth() As Long
  CellWidth = XXgrid.CellWidth
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Col
Public Property Get Col() As Long
Attribute Col.VB_Description = "Returns/sets the active cell in a FlexGrid. Not available at design time."
  Col = XXgrid.Col
End Property

Public Property Let Col(ByVal New_Col As Long)
  XXgrid.Col = New_Col
  PropertyChanged "Col"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ColAlignment
'Public Property Get ColAlignment(Index As Long) As Integer
Public Property Get ColAlignment(Index As Variant) As Integer
  ColAlignment = XXgrid.ColAlignment(Index)
End Property

'Public Property Let ColAlignment(Index As Long, ByVal New_ColAlignment As Integer)
Public Property Let ColAlignment(Index As Variant, ByVal New_ColAlignment As Integer)
Attribute ColAlignment.VB_Description = "Returns/sets the alignment of data in a column. Not available at design time (except indirectly through the FormatString property)."
  XXgrid.ColAlignment(Index) = New_ColAlignment
  PropertyChanged "ColAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ColData
'Public Property Get ColData(Index As Long) As Long
Public Property Get ColData(Index As Variant) As Long
Attribute ColData.VB_Description = "Array of long integer values with one item for each row (RowData) and for each column (ColData) of the FlexGrid. Not available at design time."
  ColData = XXgrid.ColData(Index)
End Property

'Public Property Let ColData(Index As Long, ByVal New_ColData As Long)
Public Property Let ColData(Index As Variant, ByVal New_ColData As Long)
  XXgrid.ColData(Index) = New_ColData
  PropertyChanged "ColData"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ColIsVisible
'Public Property Get ColIsVisible(Index As Long) As Boolean
Public Property Get ColIsVisible(Index As Variant) As Boolean
  ColIsVisible = XXgrid.ColIsVisible(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ColPos
'Public Property Get ColPos(Index As Long) As Long
Public Property Get ColPos(Index As Variant) As Long
  ColPos = XXgrid.ColPos(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ColPosition
'Public Property Get ColPosition(Index As Long) As Long
'  ColPosition = XXgrid.ColPosition(Index)
'End Property
'
' COLPOSITION is LET only (no GET)

'Public Property Let ColPosition(Index As Long, ByVal New_ColPosition As Long)
Public Property Let ColPosition(Index As Variant, ByVal New_ColPosition As Long)
  XXgrid.ColPosition(Index) = New_ColPosition
  PropertyChanged "ColPosition"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Cols
Public Property Get Cols() As Long
Attribute Cols.VB_Description = "Determines the total number of columns or rows in a FlexGrid."
  Cols = XXgrid.Cols
End Property

Public Property Let Cols(ByVal New_Cols As Long)
  XXgrid.Cols = New_Cols
  PropertyChanged "Cols"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ColSel
Public Property Get ColSel() As Long
Attribute ColSel.VB_Description = "Determines the starting or ending row or column for a range of cells. Not available at design time."
  ColSel = XXgrid.ColSel
End Property

Public Property Let ColSel(ByVal New_ColSel As Long)
  XXgrid.ColSel = New_ColSel
  PropertyChanged "ColSel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ColWidth
'Public Property Get ColWidth(Index As Long) As Long
Public Property Get ColWidth(Index As Variant) As Long
  ColWidth = XXgrid.ColWidth(Index)
End Property

'Public Property Let ColWidth(Index As Long, ByVal New_ColWidth As Long)
Public Property Let ColWidth(Index As Variant, ByVal New_ColWidth As Long)
Attribute ColWidth.VB_Description = "Determines the width of the specified column in Twips. Not available at design time."
  XXgrid.ColWidth(Index) = New_ColWidth
  PropertyChanged "ColWidth"
End Property

'Private Sub XXgrid_Compare(Row1 As Long, Row2 As Long, Cmp As Integer)
'  RaiseEvent Compare(Row1, Row2, Cmp)
'End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,DataBindings
Public Property Get DataBindings() As DataBindings
  Set DataBindings = XXgrid.DataBindings
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,DataSource
Public Property Get DataSource() As IRowCursor
  Set DataSource = XXgrid.DataSource
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
  Enabled = XXgrid.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
  XXgrid.Enabled = New_Enabled
  PropertyChanged "Enabled"
End Property

Private Sub XXgrid_EnterCell()
  If pHaveRowTotals And (XXgrid.Col >= XXgrid.Cols - 1) Then
    XXgrid.Col = XXgrid.Col - 1
  End If
  If pHaveColTotals And (XXgrid.Row >= XXgrid.Rows - 1) Then
    XXgrid.Row = XXgrid.Row - 1
  End If
  RaiseEvent EnterCell
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,FillStyle
Public Property Get FillStyle() As FillStyleSettings
Attribute FillStyle.VB_Description = "Determines whether setting the Text property or one of the Cell formatting properties of a FlexGrid applies the change to all selected cells."
  FillStyle = XXgrid.FillStyle
End Property

Public Property Let FillStyle(ByVal New_FillStyle As FillStyleSettings)
  XXgrid.FillStyle = New_FillStyle
  PropertyChanged "FillStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,FixedAlignment
'Public Property Get FixedAlignment(Index As Long) As Integer
Public Property Get FixedAlignment(Index As Variant) As Integer
  FixedAlignment = XXgrid.FixedAlignment(Index)
End Property

'Public Property Let FixedAlignment(Index As Long, ByVal New_FixedAlignment As Integer)
Public Property Let FixedAlignment(Index As Variant, ByVal New_FixedAlignment As Integer)
Attribute FixedAlignment.VB_Description = "Returns/sets the alignment of data in the fixed cells of a column."
  XXgrid.FixedAlignment(Index) = New_FixedAlignment
  PropertyChanged "FixedAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,FixedCols
Public Property Get FixedCols() As Long
Attribute FixedCols.VB_Description = "Returns/sets the total number of fixed (non-scrollable) columns or rows for a FlexGrid."
  FixedCols = XXgrid.FixedCols
End Property

Public Property Let FixedCols(ByVal New_FixedCols As Long)
  XXgrid.FixedCols = New_FixedCols
  PropertyChanged "FixedCols"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,FixedRows
Public Property Get FixedRows() As Long
Attribute FixedRows.VB_Description = "Returns/sets the total number of fixed (non-scrollable) columns or rows for a FlexGrid."
  FixedRows = XXgrid.FixedRows
End Property

Public Property Let FixedRows(ByVal New_FixedRows As Long)
  XXgrid.FixedRows = New_FixedRows
  PropertyChanged "FixedRows"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,FocusRect
Public Property Get FocusRect() As FocusRectSettings
Attribute FocusRect.VB_Description = "Determines whether the FlexGrid control should draw a focus rectangle around the current cell."
  FocusRect = XXgrid.FocusRect
End Property

Public Property Let FocusRect(ByVal New_FocusRect As FocusRectSettings)
  XXgrid.FocusRect = New_FocusRect
  PropertyChanged "FocusRect"
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns/sets the default font or the font for individual cells."
  Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
  Set UserControl.Font = New_Font
  Call SyncFonts
  PropertyChanged "Font"
End Property

Private Sub SyncFonts()
  Set XXgrid.Font = UserControl.Font
  Set XXcellTextbox.Font = UserControl.Font
  DoEvents
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,FontWidth
Public Property Get FontWidth() As Single
Attribute FontWidth.VB_Description = "Returns or sets the width, in points, of the font to be used for text displayed."
  FontWidth = XXgrid.FontWidth
End Property

Public Property Let FontWidth(ByVal New_FontWidth As Single)
  XXgrid.FontWidth = New_FontWidth
  PropertyChanged "FontWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
  ForeColor = XXgrid.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
  XXgrid.ForeColor = New_ForeColor
  PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ForeColorFixed
Public Property Get ForeColorFixed() As Long
Attribute ForeColorFixed.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
  ForeColorFixed = XXgrid.ForeColorFixed
End Property

Public Property Let ForeColorFixed(ByVal New_ForeColorFixed As Long)
  XXgrid.ForeColorFixed = New_ForeColorFixed
  PropertyChanged "ForeColorFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ForeColorSel
Public Property Get ForeColorSel() As Long
Attribute ForeColorSel.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
  ForeColorSel = XXgrid.ForeColorSel
End Property

Public Property Let ForeColorSel(ByVal New_ForeColorSel As Long)
  XXgrid.ForeColorSel = New_ForeColorSel
  PropertyChanged "ForeColorSel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,FormatString
Public Property Get FormatString() As String
Attribute FormatString.VB_Description = "Allows you to set up a FlexGrid's column widths, alignments, and fixed row and column text at design time. See the help file for details."
  FormatString = XXgrid.FormatString
End Property

Public Property Let FormatString(ByVal New_FormatString As String)
  XXgrid.FormatString = New_FormatString
  PropertyChanged "FormatString"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,GridColor
Public Property Get GridColor() As Long
Attribute GridColor.VB_Description = "Returns/sets the color used to draw the lines between FlexGrid cells."
  GridColor = XXgrid.GridColor
End Property

Public Property Let GridColor(ByVal New_GridColor As Long)
  XXgrid.GridColor = New_GridColor
  PropertyChanged "GridColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,GridColorFixed
Public Property Get GridColorFixed() As Long
Attribute GridColorFixed.VB_Description = "Returns/sets the color used to draw the lines between FlexGrid cells."
  GridColorFixed = XXgrid.GridColorFixed
End Property

Public Property Let GridColorFixed(ByVal New_GridColorFixed As Long)
  XXgrid.GridColorFixed = New_GridColorFixed
  PropertyChanged "GridColorFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,GridLines
Public Property Get GridLines() As GridLineSettings
Attribute GridLines.VB_Description = "Returns/sets the type of lines that should be drawn between cells."
  GridLines = XXgrid.GridLines
End Property

Public Property Let GridLines(ByVal New_GridLines As GridLineSettings)
  XXgrid.GridLines = New_GridLines
  PropertyChanged "GridLines"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,GridLinesFixed
Public Property Get GridLinesFixed() As GridLineSettings
Attribute GridLinesFixed.VB_Description = "Returns/sets the type of lines that should be drawn between cells."
  GridLinesFixed = XXgrid.GridLinesFixed
End Property

Public Property Let GridLinesFixed(ByVal New_GridLinesFixed As GridLineSettings)
  XXgrid.GridLinesFixed = New_GridLinesFixed
  PropertyChanged "GridLinesFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,GridLineWidth
Public Property Get GridLineWidth() As Integer
Attribute GridLineWidth.VB_Description = "Returns/sets the width in Pixels of the gridlines for the control."
  GridLineWidth = XXgrid.GridLineWidth
End Property

Public Property Let GridLineWidth(ByVal New_GridLineWidth As Integer)
  XXgrid.GridLineWidth = New_GridLineWidth
  PropertyChanged "GridLineWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,HighLight
Public Property Get HighLight() As HighLightSettings
Attribute HighLight.VB_Description = "Returns/sets whether selected cells appear highlighted."
  HighLight = XXgrid.HighLight
End Property

Public Property Let HighLight(ByVal New_HighLight As HighLightSettings)
  XXgrid.HighLight = New_HighLight
  PropertyChanged "HighLight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,LeftCol
Public Property Get LeftCol() As Long
Attribute LeftCol.VB_Description = "Returns/sets the leftmost visible column (other than a fixed column) in the FlexGrid. Not available at design time."
  LeftCol = XXgrid.LeftCol
End Property

Public Property Let LeftCol(ByVal New_LeftCol As Long)
  XXgrid.LeftCol = New_LeftCol
  PropertyChanged "LeftCol"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,MergeCells
Public Property Get MergeCells() As MergeCellsSettings
Attribute MergeCells.VB_Description = "Returns/sets whether cells with the same contents should be grouped in a single cell spanning multiple rows or columns."
  MergeCells = XXgrid.MergeCells
End Property

Public Property Let MergeCells(ByVal New_MergeCells As MergeCellsSettings)
  XXgrid.MergeCells = New_MergeCells
  PropertyChanged "MergeCells"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,MergeCol
'Public Property Get MergeCol(Index As Long) As Boolean
Public Property Get MergeCol(Index As Variant) As Boolean
Attribute MergeCol.VB_Description = "Returns/sets which rows (columns) should have their contents merged when the MergeCells property is set to a value other than 0 - Never."
  MergeCol = XXgrid.MergeCol(Index)
End Property

'Public Property Let MergeCol(Index As Long, ByVal New_MergeCol As Boolean)
Public Property Let MergeCol(Index As Variant, ByVal New_MergeCol As Boolean)
  XXgrid.MergeCol(Index) = New_MergeCol
  PropertyChanged "MergeCol"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,MergeRow
'Public Property Get MergeRow(Index As Long) As Boolean
Public Property Get MergeRow(Index As Variant) As Boolean
Attribute MergeRow.VB_Description = "Returns/sets which rows (columns) should have their contents merged when the MergeCells property is set to a value other than 0 - Never."
  MergeRow = XXgrid.MergeRow(Index)
End Property

'Public Property Let MergeRow(Index As Long, ByVal New_MergeRow As Boolean)
Public Property Let MergeRow(Index As Variant, ByVal New_MergeRow As Boolean)
  XXgrid.MergeRow(Index) = New_MergeRow
  PropertyChanged "MergeRow"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,MouseCol
Public Property Get MouseCol() As Long
  Set MouseIcon = XXgrid.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
  Set XXgrid.MouseIcon = New_MouseIcon
  PropertyChanged "MouseIcon"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,MousePointer
Public Property Get MousePointer() As MousePointerSettings
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
  MousePointer = XXgrid.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerSettings)
  XXgrid.MousePointer = New_MousePointer
  PropertyChanged "MousePointer"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,MouseRow
Public Property Get MouseRow() As Long
  MouseRow = XXgrid.MouseRow
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Picture
Public Property Get Picture() As Picture
  Set Picture = XXgrid.Picture
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Redraw
Public Property Get Redraw() As Boolean
Attribute Redraw.VB_Description = "Enables or disables redrawing of the FlexGrid control."
  Redraw = XXgrid.Redraw
End Property

Public Property Let Redraw(ByVal New_Redraw As Boolean)
  XXgrid.Redraw = New_Redraw
  PropertyChanged "Redraw"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a form or control."
  XXgrid.Refresh
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RemoveItem
'Public Sub RemoveItem(Index As Long)
Public Sub RemoveItem(Index As Variant)
  XXgrid.RemoveItem Index
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Row
Public Property Get Row() As Long
Attribute Row.VB_Description = "Returns/sets the active cell in a FlexGrid. Not available at design time."
  Row = XXgrid.Row
End Property

Public Property Let Row(ByVal New_Row As Long)
  XXgrid.Row = New_Row
  PropertyChanged "Row"
End Property

Private Sub XXgrid_RowColChange()
  RaiseEvent RowColChange
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RowData
'Public Property Get RowData(Index As Long) As Long
Public Property Get RowData(Index As Variant) As Long
Attribute RowData.VB_Description = "Array of long integer values with one item for each row (RowData) and for each column (ColData) of the FlexGrid. Not available at design time."
  RowData = XXgrid.RowData(Index)
End Property

'Public Property Let RowData(Index As Long, ByVal New_RowData As Long)
Public Property Let RowData(Index As Variant, ByVal New_RowData As Long)
  XXgrid.RowData(Index) = New_RowData
  PropertyChanged "RowData"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RowHeight
'Public Property Get RowHeight(Index As Long) As Long
Public Property Get RowHeight(Index As Variant) As Long
Attribute RowHeight.VB_Description = "Returns/sets the height of the specified row in Twips. Not available at design time."
  RowHeight = XXgrid.RowHeight(Index)
End Property

'Public Property Let RowHeight(Index As Long, ByVal New_RowHeight As Long)
Public Property Let RowHeight(Index As Variant, ByVal New_RowHeight As Long)
  XXgrid.RowHeight(Index) = New_RowHeight
  PropertyChanged "RowHeight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RowHeightMin
Public Property Get RowHeightMin() As Long
Attribute RowHeightMin.VB_Description = "Returns/sets a minimum row height for the entire control, in Twips."
  RowHeightMin = XXgrid.RowHeightMin
End Property

Public Property Let RowHeightMin(ByVal New_RowHeightMin As Long)
  XXgrid.RowHeightMin = New_RowHeightMin
  PropertyChanged "RowHeightMin"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RowIsVisible
'Public Property Get RowIsVisible(Index As Long) As Boolean
Public Property Get RowIsVisible(Index As Variant) As Boolean
  RowIsVisible = XXgrid.RowIsVisible(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RowPos
'Public Property Get RowPos(Index As Long) As Long
Public Property Get RowPos(Index As Variant) As Long
  RowPos = XXgrid.RowPos(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RowPosition
'Public Property Get RowPosition(Index As Long) As Long
'  RowPosition = XXgrid.RowPosition(Index)
'End Property
'
' ROWPOSITION is SET only (no GET)

'Public Property Let RowPosition(Index As Long, ByVal New_RowPosition As Long)
Public Property Let RowPosition(Index As Variant, ByVal New_RowPosition As Long)
  XXgrid.RowPosition(Index) = New_RowPosition
  PropertyChanged "RowPosition"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Rows
Public Property Get Rows() As Long
Attribute Rows.VB_Description = "Determines the total number of columns or rows in a FlexGrid."
  Rows = XXgrid.Rows
End Property

Public Property Let Rows(ByVal New_Rows As Long)
  XXgrid.Rows = New_Rows
  PropertyChanged "Rows"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,RowSel
Public Property Get RowSel() As Long
Attribute RowSel.VB_Description = "Determines the starting or ending row or column for a range of cells. Not available at design time."
  RowSel = XXgrid.RowSel
End Property

Public Property Let RowSel(ByVal New_RowSel As Long)
  XXgrid.RowSel = New_RowSel
  PropertyChanged "RowSel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ScrollBars
Public Property Get ScrollBars() As ScrollBarsSettings
Attribute ScrollBars.VB_Description = "Returns/sets whether a FlexGrid has horizontal or vertical scroll bars."
  ScrollBars = XXgrid.ScrollBars
End Property

Public Property Let ScrollBars(ByVal New_ScrollBars As ScrollBarsSettings)
  XXgrid.ScrollBars = New_ScrollBars
  PropertyChanged "ScrollBars"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ScrollTrack
Public Property Get ScrollTrack() As Boolean
Attribute ScrollTrack.VB_Description = "Returns/sets whether FlexGrid should scroll its contents while the user moves the scroll box along the scroll bars."
  ScrollTrack = XXgrid.ScrollTrack
End Property

Public Property Let ScrollTrack(ByVal New_ScrollTrack As Boolean)
  XXgrid.ScrollTrack = New_ScrollTrack
  PropertyChanged "ScrollTrack"
End Property

Private Sub XXgrid_SelChange()
  RaiseEvent SelChange
End Sub

''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MappingInfo=XXgrid,XXgrid,-1,Text
Public Property Get Text() As String
  Text = XXgrid.Text
End Property

Public Property Let Text(ByVal New_Text As String)
Dim old_text As String, proposed_text As String, the_row As Long, the_col As Long
  the_row = XXgrid.Row
  the_col = XXgrid.Col
  If WillOverwriteTotals(the_row, the_col) Then
    Exit Property
  End If
  old_text = XXgrid.Text
  proposed_text = New_Text
  XXgrid.Text = New_Text
  PropertyChanged "Text"
'  If old_text <> proposed_text Then
    Call ProcessCellDataChange(the_row, the_col, old_text, proposed_text)
'  End If
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,TextArray
'Public Property Get TextArray(Index As Long) As String
Public Property Get TextArray(Index As Variant) As String
  TextArray = XXgrid.TextArray(Index)
End Property

'Public Property Let TextArray(Index As Long, ByVal New_TextArray As String)
Public Property Let TextArray(Index As Variant, ByVal New_TextArray As String)
Dim old_text As String, proposed_text As String, the_row As Long, the_col As Long
  the_row = Int(Index / XXgrid.Cols)
  the_col = Index - (the_row * XXgrid.Cols)
  If WillOverwriteTotals(the_row, the_col) Then
    Exit Property
  End If
  old_text = XXgrid.TextArray(Index)
  proposed_text = New_TextArray
  XXgrid.TextArray(Index) = New_TextArray
  PropertyChanged "TextArray"
'  If old_text <> proposed_text Then
    Call ProcessCellDataChange(the_row, the_col, old_text, proposed_text)
'  End If
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Sort
'
' SORT is SET only (no GET)
'
'Public Property Get Sort() As Integer
'  Sort = XXgrid.Sort
'End Property

'Public Property Let Sort(ByVal New_Sort As Integer)
Public Property Let Sort(ByVal New_Sort As Variant)
  XXgrid.Sort = New_Sort
  PropertyChanged "Sort"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,TextMatrix
'Public Property Get TextMatrix(Row As Long, Col As Long) As String
Public Property Get TextMatrix(Row As Variant, Col As Variant) As String
  TextMatrix = XXgrid.TextMatrix(Row, Col)
End Property

'Public Property Let TextMatrix(Row As Variant, Col As Variant, ByVal New_TextMatrix As String)
Public Property Let TextMatrix(Row As Variant, Col As Variant, ByVal New_TextMatrix As String)
Dim old_text As String, proposed_text As String, the_row As Long, the_col As Long
  the_row = Row
  the_col = Col
  If WillOverwriteTotals(the_row, the_col) Then
    Exit Property
  End If
  old_text = XXgrid.TextMatrix(Row, Col)
  proposed_text = New_TextMatrix
  XXgrid.TextMatrix(Row, Col) = New_TextMatrix
  PropertyChanged "TextMatrix"
'  If old_text <> proposed_text Then
    Call ProcessCellDataChange(the_row, the_col, old_text, proposed_text)
'  End If
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,TextStyle
Public Property Get TextStyle() As TextStyleSettings
Attribute TextStyle.VB_Description = "Returns/sets 3D effects for displaying text."
  TextStyle = XXgrid.TextStyle
End Property

Public Property Let TextStyle(ByVal New_TextStyle As TextStyleSettings)
  XXgrid.TextStyle = New_TextStyle
  PropertyChanged "TextStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,TextStyleFixed
Public Property Get TextStyleFixed() As TextStyleSettings
Attribute TextStyleFixed.VB_Description = "Returns/sets 3D effects for displaying text."
  TextStyleFixed = XXgrid.TextStyleFixed
End Property

Public Property Let TextStyleFixed(ByVal New_TextStyleFixed As TextStyleSettings)
  XXgrid.TextStyleFixed = New_TextStyleFixed
  PropertyChanged "TextStyleFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
  ToolTipText = XXgrid.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
  XXgrid.ToolTipText = New_ToolTipText
  PropertyChanged "ToolTipText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,TopRow
Public Property Get TopRow() As Long
Attribute TopRow.VB_Description = "Returns/sets the uppermost row displayed in the FlexGrid. Not available at design time."
  TopRow = XXgrid.TopRow
End Property

Public Property Let TopRow(ByVal New_TopRow As Long)
  XXgrid.TopRow = New_TopRow
  PropertyChanged "TopRow"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Version
Public Property Get Version() As Integer
Attribute Version.VB_Description = "Returns the version of the FlexGrid control currently loaded in memory."
  Version = XXgrid.Version
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,WordWrap
Public Property Get WordWrap() As Boolean
  WordWrap = XXgrid.WordWrap
End Property

Public Property Let WordWrap(ByVal New_WordWrap As Boolean)
  XXgrid.WordWrap = New_WordWrap
  PropertyChanged "WordWrap"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Width
Public Property Get Width() As Double
  Width = UserControl.Width
End Property

Public Property Let Width(ByVal New_Width As Double)
  UserControl.Width = New_Width
  PropertyChanged "Width"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=XXgrid,XXgrid,-1,Height
Public Property Get Height() As Double
  Height = UserControl.Height
End Property

Public Property Let Height(ByVal New_Height As Double)
  UserControl.Height = New_Height
  PropertyChanged "Height"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
  PreEditCellData = ""
  EditSequenceNo = 0
  pHaveRowTotals = False
  pHaveColTotals = False
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Dim Index As Integer
Dim irow, icol
'  XXgrid.AllowBigSelection = PropBag.ReadProperty("AllowBigSelection", False)
'  XXgrid.AllowUserResizing = PropBag.ReadProperty("AllowUserResizing", 3)
'  XXgrid.Appearance = PropBag.ReadProperty("Appearance", 1)
'  XXgrid.CellAlignment = PropBag.ReadProperty("CellAlignment", 0)
'  XXgrid.CellBackColor = PropBag.ReadProperty("CellBackColor", 0)
'  XXgrid.CellFontBold = PropBag.ReadProperty("CellFontBold", 0)
'  XXgrid.CellFontItalic = PropBag.ReadProperty("CellFontItalic", 0)
'  XXgrid.CellFontName = PropBag.ReadProperty("CellFontName", "")
'  XXgrid.CellFontSize = PropBag.ReadProperty("CellFontSize", 0)
'  XXgrid.CellFontStrikeThrough = PropBag.ReadProperty("CellFontStrikeThrough", 0)
'  XXgrid.CellFontUnderline = PropBag.ReadProperty("CellFontUnderline", 0)
'  XXgrid.CellFontWidth = PropBag.ReadProperty("CellFontWidth", 0)
'  XXgrid.CellForeColor = PropBag.ReadProperty("CellForeColor", 0)
'  Set CellPicture = PropBag.ReadProperty("CellPicture", Nothing)
'  XXgrid.CellPictureAlignment = PropBag.ReadProperty("CellPictureAlignment", 0)
'  XXgrid.CellTextStyle = PropBag.ReadProperty("CellTextStyle", 0)
'  XXgrid.Col = PropBag.ReadProperty("Col", 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    XXgrid.ColAlignment(Index) = PropBag.ReadProperty("ColAlignment" & Index, 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    XXgrid.ColData(Index) = PropBag.ReadProperty("ColData" & Index, 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
''
'' COLPOSITION is SET only (no GET)
''
''  For Index = 0 To XXgrid.Cols - 1
''    XXgrid.ColPosition(Index) = PropBag.ReadProperty("ColPosition" & Index, 0)
''  Next
'  XXgrid.Cols = PropBag.ReadProperty("Cols", 2)
'  XXgrid.ColSel = PropBag.ReadProperty("ColSel", 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    XXgrid.ColWidth(Index) = PropBag.ReadProperty("ColWidth" & Index, 1)
'  Next
'  XXgrid.Enabled = PropBag.ReadProperty("Enabled", True)
'  XXgrid.FillStyle = PropBag.ReadProperty("FillStyle", 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    XXgrid.FixedAlignment(Index) = PropBag.ReadProperty("FixedAlignment" & Index, 0)
'  Next
'  XXgrid.FixedCols = PropBag.ReadProperty("FixedCols", 1)
'  XXgrid.FixedRows = PropBag.ReadProperty("FixedRows", 1)
'  XXgrid.FocusRect = PropBag.ReadProperty("FocusRect", 2)
'  Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
'  Call SyncFonts
'  XXgrid.FontWidth = PropBag.ReadProperty("FontWidth", 0)
'  XXgrid.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
'  XXgrid.ForeColorFixed = PropBag.ReadProperty("ForeColorFixed", 2147483666#)
'  XXgrid.ForeColorSel = PropBag.ReadProperty("ForeColorSel", 2147483662#)
'  XXgrid.FormatString = PropBag.ReadProperty("FormatString", "")
'  XXgrid.GridColor = PropBag.ReadProperty("GridColor", 12632256)
'  XXgrid.GridColorFixed = PropBag.ReadProperty("GridColorFixed", 0)
'  XXgrid.GridLines = PropBag.ReadProperty("GridLines", 1)
'  XXgrid.GridLinesFixed = PropBag.ReadProperty("GridLinesFixed", 2)
'  XXgrid.GridLineWidth = PropBag.ReadProperty("GridLineWidth", 1)
'  XXgrid.HighLight = PropBag.ReadProperty("HighLight", 1)
'  XXgrid.LeftCol = PropBag.ReadProperty("LeftCol", XXgrid.FixedCols)
'  XXgrid.MergeCells = PropBag.ReadProperty("MergeCells", 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    XXgrid.MergeCol(Index) = PropBag.ReadProperty("MergeCol" & Index, 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Rows - 1
'    XXgrid.MergeRow(Index) = PropBag.ReadProperty("MergeRow" & Index, 0)
'  Next
'  Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
'  XXgrid.MousePointer = PropBag.ReadProperty("MousePointer", 0)
'  XXgrid.Redraw = PropBag.ReadProperty("Redraw", True)
'  XXgrid.Row = PropBag.ReadProperty("Row", 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Rows - 1
'    XXgrid.RowData(Index) = PropBag.ReadProperty("RowData" & Index, 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Rows - 1
'    XXgrid.RowHeight(Index) = PropBag.ReadProperty("RowHeight" & Index, 1)
'  Next
'  XXgrid.RowHeightMin = PropBag.ReadProperty("RowHeightMin", 1)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'' ROWPOSITION is SET only (no GET)
''
''  For Index = 0 To XXgrid.Rows - 1
''    XXgrid.RowPosition(Index) = PropBag.ReadProperty("RowPosition" & Index, 0)
''  Next
'  XXgrid.Rows = PropBag.ReadProperty("Rows", 2)
'  XXgrid.RowSel = PropBag.ReadProperty("RowSel", 0)
'  XXgrid.ScrollBars = PropBag.ReadProperty("ScrollBars", 3)
'  XXgrid.ScrollTrack = PropBag.ReadProperty("ScrollTrack", True)
'  XXgrid.Text = PropBag.ReadProperty("Text", "")
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To (XXgrid.Rows * XXgrid.Cols) - 1
'    XXgrid.TextArray(Index) = PropBag.ReadProperty("TextArray" & Index, "")
'  Next
'' Sort is SET only (no GET)
''  XXgrid.Sort = PropBag.ReadProperty("Sort", 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For iRow = 0 To XXgrid.Rows - 1
'    For iCol = 0 To XXgrid.Cols - 1
'      XXgrid.TextMatrix(iRow, iCol) = PropBag.ReadProperty("TextMatrix" & "R" & iRow & "C" & iCol, "")
'    Next
'  Next
'  XXgrid.TextStyle = PropBag.ReadProperty("TextStyle", 0)
'  XXgrid.TextStyleFixed = PropBag.ReadProperty("TextStyleFixed", 0)
'  XXgrid.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
'  XXgrid.TopRow = PropBag.ReadProperty("TopRow", XXgrid.FixedRows)
'  XXgrid.WordWrap = PropBag.ReadProperty("WordWrap", False)
'  UserControl.Width = PropBag.ReadProperty("Width", 3000)
'  UserControl.Height = PropBag.ReadProperty("Height", 3000)

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
Dim Index As Integer
Dim irow, icol
'  Call PropBag.WriteProperty("AllowBigSelection", XXgrid.AllowBigSelection, False)
'  Call PropBag.WriteProperty("AllowUserResizing", XXgrid.AllowUserResizing, 3)
'  Call PropBag.WriteProperty("Appearance", XXgrid.Appearance, 1)
'  Call PropBag.WriteProperty("CellAlignment", XXgrid.CellAlignment, 0)
'  Call PropBag.WriteProperty("CellBackColor", XXgrid.CellBackColor, 0)
'  Call PropBag.WriteProperty("CellFontBold", XXgrid.CellFontBold, 0)
'  Call PropBag.WriteProperty("CellFontItalic", XXgrid.CellFontItalic, 0)
'  Call PropBag.WriteProperty("CellFontName", XXgrid.CellFontName, "")
'  Call PropBag.WriteProperty("CellFontSize", XXgrid.CellFontSize, 0)
'  Call PropBag.WriteProperty("CellFontStrikeThrough", XXgrid.CellFontStrikeThrough, 0)
'  Call PropBag.WriteProperty("CellFontUnderline", XXgrid.CellFontUnderline, 0)
'  Call PropBag.WriteProperty("CellFontWidth", XXgrid.CellFontWidth, 0)
'  Call PropBag.WriteProperty("CellForeColor", XXgrid.CellForeColor, 0)
'  Call PropBag.WriteProperty("CellPicture", CellPicture, Nothing)
'  Call PropBag.WriteProperty("CellPictureAlignment", XXgrid.CellPictureAlignment, 0)
'  Call PropBag.WriteProperty("CellTextStyle", XXgrid.CellTextStyle, 0)
'  Call PropBag.WriteProperty("Col", XXgrid.Col, 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    Call PropBag.WriteProperty("ColAlignment" & Index, XXgrid.ColAlignment(Index), 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'   Call PropBag.WriteProperty("ColData" & Index, XXgrid.ColData(Index), 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
''  For Index = 0 To XXgrid.Cols - 1
''    Call PropBag.WriteProperty("ColPosition" & Index, XXgrid.ColPosition(Index), 0)
''  Next
'  Call PropBag.WriteProperty("Cols", XXgrid.Cols, 2)
'  Call PropBag.WriteProperty("ColSel", XXgrid.ColSel, 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    Call PropBag.WriteProperty("ColWidth" & Index, XXgrid.ColWidth(Index), 1)
'  Next
'  Call PropBag.WriteProperty("Enabled", XXgrid.Enabled, True)
'  Call PropBag.WriteProperty("FillStyle", XXgrid.FillStyle, 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    Call PropBag.WriteProperty("FixedAlignment" & Index, XXgrid.FixedAlignment(Index), 0)
'  Next
'  Call PropBag.WriteProperty("FixedCols", XXgrid.FixedCols, 1)
'  Call PropBag.WriteProperty("FixedRows", XXgrid.FixedRows, 1)
'  Call PropBag.WriteProperty("FocusRect", XXgrid.FocusRect, 2)
'  Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
'  Call PropBag.WriteProperty("FontWidth", XXgrid.FontWidth, 0)
'  Call PropBag.WriteProperty("ForeColor", XXgrid.ForeColor, &H80000008)
'  Call PropBag.WriteProperty("ForeColorFixed", XXgrid.ForeColorFixed, 2147483666#)
'  Call PropBag.WriteProperty("ForeColorSel", XXgrid.ForeColorSel, 2147483662#)
'  Call PropBag.WriteProperty("FormatString", XXgrid.FormatString, "")
'  Call PropBag.WriteProperty("GridColor", XXgrid.GridColor, 12632256)
'  Call PropBag.WriteProperty("GridColorFixed", XXgrid.GridColorFixed, 0)
'  Call PropBag.WriteProperty("GridLines", XXgrid.GridLines, 1)
'  Call PropBag.WriteProperty("GridLinesFixed", XXgrid.GridLinesFixed, 2)
'  Call PropBag.WriteProperty("GridLineWidth", XXgrid.GridLineWidth, 1)
'  Call PropBag.WriteProperty("HighLight", XXgrid.HighLight, 1)
'  Call PropBag.WriteProperty("LeftCol", XXgrid.LeftCol, 0)
'  Call PropBag.WriteProperty("MergeCells", XXgrid.MergeCells, 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Cols - 1
'    Call PropBag.WriteProperty("MergeCol" & Index, XXgrid.MergeCol(Index), 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Rows - 1
'    Call PropBag.WriteProperty("MergeRow" & Index, XXgrid.MergeRow(Index), 0)
'  Next
'  Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
'  Call PropBag.WriteProperty("MousePointer", XXgrid.MousePointer, 0)
'  Call PropBag.WriteProperty("Redraw", XXgrid.Redraw, True)
'  Call PropBag.WriteProperty("Row", XXgrid.Row, 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Rows - 1
'    Call PropBag.WriteProperty("RowData" & Index, XXgrid.RowData(Index), 0)
'  Next
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To XXgrid.Rows - 1
'    Call PropBag.WriteProperty("RowHeight" & Index, XXgrid.RowHeight(Index), 1)
'  Next
'  Call PropBag.WriteProperty("RowHeightMin", XXgrid.RowHeightMin, 1)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
''  For Index = 0 To XXgrid.Rows - 1
''    Call PropBag.WriteProperty("RowPosition" & Index, XXgrid.RowPosition(Index), 0)
''  Next
'  Call PropBag.WriteProperty("Rows", XXgrid.Rows, 2)
'  Call PropBag.WriteProperty("RowSel", XXgrid.RowSel, 0)
'  Call PropBag.WriteProperty("ScrollBars", XXgrid.ScrollBars, 3)
'  Call PropBag.WriteProperty("ScrollTrack", XXgrid.ScrollTrack, True)
'  Call PropBag.WriteProperty("Text", XXgrid.Text, "")
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For Index = 0 To (XXgrid.Rows * XXgrid.Cols) - 1
'    Call PropBag.WriteProperty("TextArray" & Index, XXgrid.TextArray(Index), "")
'  Next
''  Call PropBag.WriteProperty("Sort", XXgrid.Sort, 0)
''TO DO: The member you have mapped to contains an array of data.
''   You must supply the code to persist the array.  A prototype
''   line is shown next:
'  For iRow = 0 To XXgrid.Rows - 1
'    For iCol = 0 To XXgrid.Cols - 1
'      Call PropBag.WriteProperty("TextMatrix" & "R" & iRow & "C" & iCol, XXgrid.TextMatrix(iRow, iCol), "")
'    Next
'  Next
'  Call PropBag.WriteProperty("TextStyle", XXgrid.TextStyle, 0)
'  Call PropBag.WriteProperty("TextStyleFixed", XXgrid.TextStyleFixed, 0)
'  Call PropBag.WriteProperty("ToolTipText", XXgrid.ToolTipText, "")
'  Call PropBag.WriteProperty("TopRow", XXgrid.TopRow, 0)
'  Call PropBag.WriteProperty("WordWrap", XXgrid.WordWrap, False)
'  Call PropBag.WriteProperty("Width", UserControl.Width, 2000)
'  UserControl.Width = PropBag.ReadProperty("Width", 3000)
'  UserControl.Height = PropBag.ReadProperty("Height", 3000)

End Sub

